<template>
  <h1>Orden generada {{ estado }}</h1>

  <div class="q-pa-md">
    <q-linear-progress
      size="25px"
      :value="progress"
      :buffer="buffer"
      color="negative"
      class="q-mt-sm"
    >
      <div class="absolute-full flex flex-center">
        <q-badge color="white" text-color="negative" :label="progressLabel" />
      </div>
    </q-linear-progress>
  </div>
  <q-btn
    color="primary"
    class="full-width"
    label="Pantalla Principal"
    @click="devuelvo"
  />
</template>

<script>
import { useRoute, useRouter } from "vue-router";
import { ref, onMounted, onBeforeUnmount, computed } from "vue";
import { SessionStorage } from "quasar";
//...
export default {
  //...

  setup() {
    const route = useRoute();
    const router = useRouter();
    const estado = route.query.estado;
    const progress = ref(0.01);
    const buffer = ref(0.01);
    const token = SessionStorage.getItem("jwt");

    let interval, bufferInterval;

    onMounted(() => {
      interval = setInterval(() => {
        if (progress.value >= 1) {
          progress.value = 0.01;
          buffer.value = 0.01;
          return router.push({ name: "home" });
          // return;
        }

        progress.value = Math.min(1, buffer.value, progress.value + 0.1);
      }, 700 + Math.random() * 1000);

      bufferInterval = setInterval(() => {
        if (buffer.value < 1) {
          buffer.value = Math.min(1, buffer.value + Math.random() * 0.2);
        }
      }, 700);
    });

    onBeforeUnmount(() => {
      clearInterval(interval);
      clearInterval(bufferInterval);
    });
    return {
      /*   updatePedido(value, initialValue, id) {
        
        api
          .put(`pedidos/${id}/1`, "", {
            headers: {
              accept: "application/json",
              Authorization: token,
            },
          })
          .then((response) => {
            $q.notify({
              color: "positive",
              position: "bottom",
              message: `Se actualizo al estado ${
                estados[value - 1].estado
              } correctamente`,
              icon: "mood",
            });
          })
          .catch((error) => {
            $q.notify({
              color: "negative",
              position: "bottom",
              message: `Mensaje ${error}`,
              icon: "report_problem",
            });
          });
      }, */
      devuelvo() {
        return router.push({ name: "home" });
      },
      estado,
      progress,
      progressLabel: computed(() => (progress.value * 100).toFixed(2) + "%"),
      buffer,
    };
  },
  //...
};
</script>
